var cliptaTB_history=[];
var prefs = Components.classes["@mozilla.org/preferences-service;1"].
              getService(Components.interfaces.nsIPrefBranch);

cliptaTB_loadHistory()
function cliptaTB_Search(event, searchurl){ 
    var URL = "";  
	
	var searchTermsBox = document.getElementById("cliptaTB-SearchTerms");
	var searchTerms = cliptaTB_TrimString(searchTermsBox.value); 
	cliptaTB_addHistory(searchTerms )
	searchTerms = cliptaTB_ConvertTermsToURI(searchTerms);
	URL=searchurl+"?q="+searchTerms 
    cliptaTB_LoadURL(URL);
}
function cliptaTB_addHistory(keyword){
	if(keyword.length<=0) return false;
	if(searchInArray(keyword, cliptaTB_history)) return false;
	cliptaTB_loadHistory()
	if(cliptaTB_history.length>10){
		cliptaTB_history.pop()
	}
	cliptaTB_history.splice(0,0,keyword)
	cliptaTB_saveHistory()
}

function searchInArray(keyword, arr){
		for(i in arr){
			if(arr[i]==keyword){
				return true
			}
		}
		return false;
}
function cliptaTB_loadHistory(){	
    cliptaTB_history = prefs.getCharPref("extensions.cliptatoolbar.history").split("||");	
}

function cliptaTB_saveHistory(){	
    prefs.setCharPref("extensions.cliptatoolbar.history",cliptaTB_history.join("||"));	
}

function cliptaTB_clearHistory(){
	cliptaTB_history=[]
	cliptaTB_saveHistory()
	cliptaTB_loadHistory()
}

function cliptaTB_TrimString(string){
    if (!string)
        return "";
    string = string.replace(/^\s+/, ''); 
    string = string.replace(/\s+$/, ''); 
    string = string.replace(/\s+/g, ' ');
    return string; 
}

function cliptaTB_ConvertTermsToURI(terms){	    
    var termArray = new Array();     
    termArray = terms.split(" ");
    var result = "";
    for(var i=0; i<termArray.length; i++){
        if(i > 0)
            result += "+";
        result += encodeURIComponent(termArray[i]);
    } 
    return result; 
}



function cliptaTB_LoadURL(url){
    window._content.document.location = url;
    window.content.focus();
}

function cliptaTB_KeyHandler(event, searchurl){
    if(event.keyCode == event.DOM_VK_RETURN)
    cliptaTB_Search(event, searchurl);
}

function cliptaTB_Populate(){

    var menu = document.getElementById("cliptaTB-SearchTermsMenu");

    for(var i=menu.childNodes.length - 1; i >= 0; i--){
        menu.removeChild(menu.childNodes.item(i));
    }
	cliptaTB_loadHistory()	

	for(var i=0; i<cliptaTB_history.length; i++){
		var tempItem = document.createElement("menuitem");
		tempItem.setAttribute("label", cliptaTB_history[i]);
		menu.appendChild(tempItem);
	}
	
}

function cliptaTB_update()
{
    try {
        if (navigator.userAgent.indexOf('Firefox') != -1 || navigator.userAgent.indexOf('BonEcho') != -1 || navigator.userAgent.indexOf('Minefield') != -1)
        {
            var id = clipta_toolbar_tool.guid;

            var itemType = Components.interfaces.nsIUpdateItem.TYPE_EXTENSION;
            var gExtensionManager = Components.classes["@mozilla.org/extensions/manager;1"]
                    .getService(Components.interfaces.nsIExtensionManager);

            var items;
            try {
                items = gExtensionManager.getItemList(id, itemType, { });
                var updates = Components.classes["@mozilla.org/updates/update-service;1"]
                        .getService(Components.interfaces.nsIUpdateService);

                updates.checkForUpdates(items, items.length, itemType, Components.interfaces.nsIUpdateService.SOURCE_EVENT_USER, window);
            }
            catch(e)
            {
                BrowserOpenExtensions('extensions');
                items = [gExtensionManager.getItemForID(id)];
                gExtensionManager.update(items, items.length, false, null);
            }
        }
    } catch(e) {
        try {
            const EMTYPE = "Extension:Manager";
            var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
                    .getService(Components.interfaces.nsIWindowMediator);
            var theEM = wm.getMostRecentWindow(EMTYPE);
            if (theEM) {
                theEM.focus();
                return;
            }
            const EMURL = "chrome://mozapps/content/extensions/extensions.xul";
            const EMFEATURES = "chrome,menubar,extra-chrome,toolbar,dialog=no,resizable";
            clipta_toolbar_wnd = 0;
            clipta_toolbar_wnd = window.openDialog(EMURL, "", EMFEATURES);

            setTimeout('postupdate();', 250);
            return;
        } catch(e) {
        }
    }
}

function postupdate()
{
    try
    {
        if (clipta_toolbar_wnd == 0) {
            setTimeout('postupdate();', 250);
            return;
        }
        var item = clipta_toolbar_wnd.document.getElementById('checkUpdatesAllButton');
        item.doCommand();
    } catch(e) {
    }
}

function cliptaTB_changeLocale(locale){
	prefs.setBoolPref("browser.preferences.instantApply",true);	
	prefs.setCharPref("general.useragent.locale",locale);
	askRestart()
}

function askRestart(){
	var oPromptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
	var sTitle = "You need to restart the browser"
	var sMsg = "You need to restart the browser to see the toolbar in the selected language";
	//var sTitle = document.getElementById("cliptaTB-restartTitle").getAttribute('label');
	//var sMsg = document.getElementById("cliptaTB-restartMessage").getAttribute('label');
	//var sNotify = document.getElementById("cliptaTB-restartNotify").getAttribute('label');
	var bRestart = oPromptService.confirm(window,sTitle, sMsg);
	if(bRestart)	cliptaTB_loadAboutConfigAndRestart()
}

function cliptaTB_loadAboutConfigAndRestart(){
	window.open("chrome://cliptatoolbar/content/localereload.xul", "localereload", "centerscreen,chrome,close,titlebar,modal",cliptaTB_restartFirefox); 
	setTimeout('cliptaTB_restartFirefox();', 500);
}

function cliptaTB_openWall(){
	window.openDialog("chrome://cliptatoolbar/content/wall.xul","cliptawall", 
		"dialog=no,chrome,width=900,height=290",this,window);  
}

function cliptaTB_restartFirefox(){
		
		if (typeof canQuitApplication == "function" && canQuitApplication()){
			var oAppStartup = Components.classes["@mozilla.org/toolkit/app-startup;1"].getService(Components.interfaces.nsIAppStartup);
			if (!oAppStartup.eRestart) throw("You need to restart the browser manually");
			var oRPref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("browser.sessionstore.");
			oRPref.setBoolPref("resume_session_once", true);
			oAppStartup.quit(oAppStartup.eAttemptQuit | oAppStartup.eRestart);
		}
}

function cliptaTB_resetLocale(){
	var defaultLocale=false
	var defLocaleBranch=Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getDefaultBranch("general.useragent.");
	try{
		defaultLocale=defLocaleBranch.getCharPref("locale");
	}catch(e){LOG(e)}	
	if(defaultLocale){
		prefs.setCharPref("general.useragent.locale",defaultLocale);
		askRestart()
	}
}

//for debugging:
function LOG(msg) {
 // return false;
  var consoleService = Components.classes["@mozilla.org/consoleservice;1"]
                                 .getService(Components.interfaces.nsIConsoleService);
  consoleService.logStringMessage(msg);
}
